/*
 * Copyright (C) 2008 Pleyo.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  Neither the name of Pleyo nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PLEYO AND ITS CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL PLEYO OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef DeprecatedPtrQueue_h
#define DeprecatedPtrQueue_h
/**
 *  @file  DeprecatedPtrQueue.t
 *  DeprecatedPtrQueue description
 *  Repository informations :
 * - $URL$
 * - $Rev$
 * - $Date: 2012/05/10 10:21:10 $
 */
#include "BALBase.h"

#include "DeprecatedPtrList.h"

namespace WebCore {

template<class T> class DeprecatedPtrQueue {
public:
    /**
     *  isEmpty description
     * @param[in] : description
     * @param[out] : description
     * @code
     * @endcode
     */
    bool isEmpty() const ;
    /**
     *  *dequeue description
     * @param[in] : description
     * @param[out] : description
     * @code
     * @endcode
     */
    T *dequeue() ;
    /**
     *  enqueue description
     * @param[in] : description
     * @param[out] : description
     * @code
     * @endcode
     */
    void enqueue(const T *item) ;
    /**
     *  count description
     * @param[in] : description
     * @param[out] : description
     * @code
     * @endcode
     */
    unsigned count() const ;
    /**
     *  *head description
     * @param[in] : description
     * @param[out] : description
     * @code
     * @endcode
     */
    T *head() const ;
    /**
     *  &operator= description
     * @param[in] : description
     * @param[out] : description
     * @code
     * @endcode
     */
    DeprecatedPtrQueue<T> &operator=(const DeprecatedPtrQueue<T> &q) ;

 private:
    DeprecatedPtrList<T> list;
};

}

#endif /* DeprecatedPtrQueue_h */




