#define DEEPSEE_SIGNAL_USE 1
#include DEEPSEE_INCLUDE

#include <cppunit/CompilerOutputter.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/ui/text/TestRunner.h>

//create deepsee framework
DS_INIT_DEEPSEE_FRAMEWORK();

int main(int argc, char* argv[])
{
  //ask deepsee to catch all signals (including segfault)
  DS_SIGNAL_CATCH_ALL();


  // Get the top level suite from the registry
  CppUnit::Test *suite = CppUnit::TestFactoryRegistry::getRegistry().makeTest();

  // Adds the test to the list of test to run
  CppUnit::TextUi::TestRunner runner;
  runner.addTest( suite );

  // Change the default outputter to a compiler error format outputter
  runner.setOutputter( new CppUnit::CompilerOutputter( &runner.result(),
                                                       std::cerr ) );
  // Run the tests.
  bool wasSucessful = runner.run();

  //free DeepSee framework
  DS_CLEAN_DEEPSEE_FRAMEWORK();

  // Return error code 1 if the one of test failed.
  return wasSucessful ? 0 : 1;
}
