// ==UserScript==
// @name          YouTube Fullscreen Fix
// @namespace     none
// @description   Fixes YouTube Fullscreen mode.
// @include       http://youtube.*/watch*
// @include       http://*.youtube.com/watch*
// @include       http://www.youtube.com/embed/*
// @include       https://youtube.*/watch*
// @include       https://*.youtube.com/watch*
// @include       https://www.youtube.com/embed/*
// @version       $VER: Youtube Fullscreen Fix 1.11 (04.08.2012)
// @url           http://fabportnawak.free.fr/owb/scripts/Youtube_Fullscreen_Fix.js
// ==/UserScript==

var embedded = document.location.href.indexOf("/embed/") !== -1;
var allHTMLTags = document.getElementsByTagName("*");
var found = false;

function goFullscreen(e)
{
    e.stopPropagation();

	for (i=0; i < allHTMLTags.length; i++)
	{
		if(allHTMLTags[i].className == "video-stream html5-main-video" && allHTMLTags[i].src != "")
		{
			allHTMLTags[i].webkitEnterFullScreen();
		}
	}

	return false;
}

function bindEvent()
{
	if(!found)
	{
		for (i=0; i < allHTMLTags.length; i++)
		{
			var name = allHTMLTags[i].className;

			if (name && name.length && name.search("html5-fullscreen-button") != -1)
			{
				found = true;

				allHTMLTags[i].addEventListener('click', goFullscreen, true);	
				if(embedded)
				{
					allHTMLTags[i].innerHTML = '<img class="yt-uix-button-icon yt-uix-button-icon-html5" src="//s.ytimg.com/yt/img/pixel-vfl3z5WfW.gif" alt="" onclick="return goFullscreen(event);">';
				}
			}
			else if (embedded && name && name.length && name.search("html5-quality-button") != -1)
			{
				found = true;

				allHTMLTags[i].addEventListener('click', goFullscreen, true);
				allHTMLTags[i].innerHTML = '<img class="yt-uix-button-icon yt-uix-button-icon-html5" src="//s.ytimg.com/yt/img/pixel-vfl3z5WfW.gif" alt="" onclick="return goFullscreen(event);">';
			}
		}
	}
	else
	{
		window.clearInterval(timer);
	}
}

// Lame workaround
var timer = window.setInterval(bindEvent, 1000);
